      Subroutine open_lut_mwr(
     $                    kextci_lut_nf,salbci_lut_nf,asymci_lut_nf,
     &                    kextcw_lut_nf,salbcw_lut_nf,asymcw_lut_nf,
     &                    kextrr_lut_nf,salbrr_lut_nf,asymrr_lut_nf,
     &                    kextsn_lut_nf,salbsn_lut_nf,asymsn_lut_nf,
     &                    kextgr_lut_nf,salbgr_lut_nf,asymgr_lut_nf,
     &                    kexthl_lut_nf,salbhl_lut_nf,asymhl_lut_nf,
     &                    kextml_lut_nf,salbml_lut_nf,asymml_lut_nf,
     &                    pts_temp_w, pts_temp_i, pts_hydro,
     &                    npts_temp, npts_hydro )
c
c This subroutine reads the Mie lookup tables created by the
c program stored in "src/MieLUT". Any changes made to the LUT
c format must be reflected in this subroutine (and its radar
c counterpart, "src/simulator/radar/open-lut-rdr.f"). Make sure
c that the specified file names match existing LUTs. The path
c to LUTs is given by "lutdir" defined in "../MAINparameters.inc".
c
      Implicit NONE
c
      Include '../MAINparameters.inc'
c
      Integer nf
      real *4 kextrr_lut_nf(mxpts_temp, mxpts_hydro, mxfreq) 
      real *4 salbrr_lut_nf(mxpts_temp, mxpts_hydro, mxfreq)
      real *4 asymrr_lut_nf(mxpts_temp, mxpts_hydro, mxfreq)
      real *4 kextci_lut_nf(mxpts_temp, mxpts_hydro, mxfreq) 
      real *4 salbci_lut_nf(mxpts_temp, mxpts_hydro, mxfreq)
      real *4 asymci_lut_nf(mxpts_temp, mxpts_hydro, mxfreq)
      real *4 kextcw_lut_nf(mxpts_temp, mxpts_hydro, mxfreq)
      real *4 salbcw_lut_nf(mxpts_temp, mxpts_hydro, mxfreq)
      real *4 asymcw_lut_nf(mxpts_temp, mxpts_hydro, mxfreq)
      real *4 kextsn_lut_nf(mxpts_temp, mxpts_hydro, mxfreq)
      real *4 salbsn_lut_nf(mxpts_temp, mxpts_hydro, mxfreq)
      real *4 asymsn_lut_nf(mxpts_temp, mxpts_hydro, mxfreq)
      real *4 kextgr_lut_nf(mxpts_temp, mxpts_hydro, mxfreq) 
      real *4 salbgr_lut_nf(mxpts_temp, mxpts_hydro, mxfreq)
      real *4 asymgr_lut_nf(mxpts_temp, mxpts_hydro, mxfreq)
      real *4 kexthl_lut_nf(mxpts_temp, mxpts_hydro, mxfreq) 
      real *4 salbhl_lut_nf(mxpts_temp, mxpts_hydro, mxfreq)
      real *4 asymhl_lut_nf(mxpts_temp, mxpts_hydro, mxfreq)
      real *4 kextml_lut_nf(mxpts_hydro, mxfreq) 
      real *4 salbml_lut_nf(mxpts_hydro, mxfreq)
      real *4 asymml_lut_nf(mxpts_hydro, mxfreq)
      real *4 frequency
      Integer i,j
      Integer npts_temp,npts_hydro
      Character*3 nch(mxfreq)
      Character fname_in*13

c #####################################################################
c "nch(*)" should be specified so it matches the labels of lookup tables.
c #####################################################################
      nch(1) = '10G'
      nch(2) = '19G'
      nch(3) = '21G'
      nch(4) = '37G'
      nch(5) = '85G'
c
      Do 100 nf = 1 , mxfreq
c
      Do 10 i = 1, mxpts_temp
         Do 10 j = 1, mxpts_hydro
            kextci_lut_nf(i,j,nf) = 0.
            salbci_lut_nf(i,j,nf) = 0.
            asymci_lut_nf(i,j,nf) = 0.
            kextcw_lut_nf(i,j,nf) = 0.
            salbcw_lut_nf(i,j,nf) = 0.
            asymcw_lut_nf(i,j,nf) = 0.
            kexthl_lut_nf(i,j,nf) = 0.
            salbhl_lut_nf(i,j,nf) = 0.
            asymhl_lut_nf(i,j,nf) = 0.
            kextsn_lut_nf(i,j,nf) = 0.
            salbsn_lut_nf(i,j,nf) = 0.
            asymsn_lut_nf(i,j,nf) = 0.
            kextgr_lut_nf(i,j,nf) = 0.
            salbgr_lut_nf(i,j,nf) = 0.
            asymgr_lut_nf(i,j,nf) = 0.
            kextrr_lut_nf(i,j,nf) = 0.
            salbrr_lut_nf(i,j,nf) = 0.
            asymrr_lut_nf(i,j,nf) = 0.
 10   Continue
      Do 13 j = 1, mxpts_hydro
            kextml_lut_nf(j,nf) = 0.
            salbml_lut_nf(j,nf) = 0.
            asymml_lut_nf(j,nf) = 0.
 13   Continue
c
c Cloud Ice
c
      fname_in = 'CI-mwr'//nch(nf)//'.dat'
      Open ( Unit=50, File=lutdir//fname_in )
c
      read(50,*) npts_temp, npts_hydro
      read(50,*) (pts_temp_i(i),i=1,npts_temp)
      read(50,*) (pts_hydro(i),i=1,npts_hydro)
      read(50,*) frequency
c
      read(50,*) ((kextci_lut_nf(i,j,nf),salbci_lut_nf(i,j,nf),
     &                                   asymci_lut_nf(i,j,nf),
     &                      j = 1,npts_hydro),i = 1,npts_temp)
c
      close (50)
c
c Cloud Water
c
      fname_in = 'CW-mwr'//nch(nf)//'.dat'
      Open ( Unit=50, File=lutdir//fname_in )
c
      read(50,*) npts_temp, npts_hydro
      read(50,*) (pts_temp_w(i),i=1,npts_temp)
      read(50,*) (pts_hydro(i),i=1,npts_hydro)
      read(50,*) frequency
c
      read(50,*) ((kextcw_lut_nf(i,j,nf),salbcw_lut_nf(i,j,nf),
     &                                   asymcw_lut_nf(i,j,nf),
     &                      j = 1,npts_hydro),i = 1,npts_temp)
c
      close (50)
c
c Rain
c
      fname_in = 'RR-mwr'//nch(nf)//'.dat'
      Open ( Unit=50, File=lutdir//fname_in )
c
      read(50,*) npts_temp, npts_hydro
      read(50,*) (pts_temp_w(i),i=1,npts_temp)
      read(50,*) (pts_hydro(i),i=1,npts_hydro)
      read(50,*) frequency
c
      read(50,*) ((kextrr_lut_nf(i,j,nf),salbrr_lut_nf(i,j,nf),
     &                                   asymrr_lut_nf(i,j,nf),
     &                      j = 1,npts_hydro),i = 1,npts_temp)
c
      close (50)
c
c Snow
c
      fname_in = 'SN-mwr'//nch(nf)//'.dat'
      Open ( Unit=50, File=lutdir//fname_in )
c
      read(50,*) npts_temp, npts_hydro
      read(50,*) (pts_temp_i(i),i=1,npts_temp)
      read(50,*) (pts_hydro(i),i=1,npts_hydro)
      read(50,*) frequency
c
      read(50,*) ((kextsn_lut_nf(i,j,nf),salbsn_lut_nf(i,j,nf),
     &                                   asymsn_lut_nf(i,j,nf),
     &                      j = 1,npts_hydro),i = 1,npts_temp)
c
      close (50)
c
c Graupel
c
      fname_in = 'GR-mwr'//nch(nf)//'.dat'
      Open ( Unit=50, File=lutdir//fname_in )
c
      read(50,*) npts_temp, npts_hydro
      read(50,*) (pts_temp_i(i),i=1,npts_temp)
      read(50,*) (pts_hydro(i),i=1,npts_hydro)
      read(50,*) frequency
c
      read(50,*) ((kextgr_lut_nf(i,j,nf),salbgr_lut_nf(i,j,nf),
     &                                   asymgr_lut_nf(i,j,nf),
     &                      j = 1,npts_hydro),i = 1,npts_temp)
c
      close (50)
c
c Hail
c
      fname_in = 'HL-mwr'//nch(nf)//'.dat'
      Open ( Unit=50, File=lutdir//fname_in )
c
      read(50,*) npts_temp, npts_hydro
      read(50,*) (pts_temp_i(i),i=1,npts_temp)
      read(50,*) (pts_hydro(i),i=1,npts_hydro)
      read(50,*) frequency
c
      read(50,*) ((kexthl_lut_nf(i,j,nf),salbhl_lut_nf(i,j,nf),
     &                                   asymhl_lut_nf(i,j,nf),
     &                       j = 1,npts_hydro),i = 1,npts_temp)
c
      close (50)
c
c Melting particles
c
      fname_in = 'ML-mwr'//nch(nf)//'.dat'
      Open ( Unit=50, File=lutdir//fname_in )
c
      read(50,*) npts_hydro
      read(50,*) (pts_hydro(i),i=1,npts_hydro)
      read(50,*) frequency
c
      read(50,*) (kextml_lut_nf(j,nf),salbml_lut_nf(j,nf),
     &                                 asymml_lut_nf(j,nf),
     &                                   j = 1,npts_hydro)
c
      close (50)
c
 100   Continue
c
      Return
      End

