      Subroutine SIMvisir
     &                 (ngridx, ngridy, nlyr, wavel, znth_slr, znth_obs,
     &                  azmth, hgt_lev, press_lev, temp_lev,
     &                  relhum_avg, cloud_water_avg, rain_avg, 
     &                  cloud_ice_avg, snow_avg, graupel_avg, hail_avg, 
     &                  background, I_visIR )
c
      Include '../MAINparameters.inc'
c
C
      include 'VISIRparameters.inc'
C
      integer nw
      real *4 TBB
      PARAMETER (PI=3.141592653,RAD=PI/180.0,PSTD=1013.25)
      CHARACTER ERR*64
c
      CHARACTER IDM(KNM)*8
      DIMENSION WMOL(KNM,10),RAMS(KNM,10),ALT(KNL),PMATM(KNL,KATM)
     & ,TMATM(KNL,KATM),DNSTY(KNL,KATM),AMOL(KNL,KNM1,KATM)
     & ,TRAC(KNL,KNM2),IDMS(KNM,10)
C FOR ABGAS1
      DIMENSION AMTPB(53),TAUM(3,KNM),TWGP(3,KNM),AAA(KNM),CPSS(KNM)
     & ,AMTP(KNM),TX(KNM),WM(KNM),AMTPBA(53,KNL),TAUB(3),WGTB(3)
C FOR SCALD
      DIMENSION IBMOL(53),DENSTY(53)
C FOR RTRN21
      DIMENSION AM1U(KNA1U),AM0(KNA0),THK(KNLN),OMG(KNLN)
     &,NLGN1(KNLN),G(KLGN1,KNLN),ANG(KNANG),PHSF(KNANG,KNLN)
     &,CPLK(KPLK1,KNLN),UTAU(KNTAU),FLXD(KNA0,KNTAU)
     &,FLXU(KNA0,KNTAU),AI(KNA1U,KNA0,KNFI,KNTAU),FI(KNFI)
C FOR GTPH3A
      DIMENSION SZP(KINTVL),R(KINTVL),V(KINTVL)
     & ,PH(KNANG,KPOL)
C OTHERS
      PARAMETER (KNW0=50,KPOLY=6)
      DIMENSION WL(KNW),DW(KNW),C0(KNW),RX(KNW0),RF(KNW0),PRS(KNLN1)
     & ,TMP(KNLN1),PHSM(KNANG),PHSA(KNANG),IPB(KNLN1)
     & ,TAURA(KNLN),SCARA(KNLN),TKD(3,KNL),WGT(3,KNL)
     & ,TH0(KNA0),TH(KNA1U),AI0(KNA1U,KNA0,KNFI)
     & ,ISPC9(KPOLY),NMODE9(KPOLY)
     & ,CE500(KPOLY),PR(6,4)

      Real AMOL2(KNLN+1,28),AMOLM(KNLN+1),ALTSTD(KNLN+1)
      real CLDW(KNLN),CLDI(KNLN),SNOW(KNLN),RAIN(KNLN)
      Real SLPR(KNLN),SLPS(KNLN)
      Character out_profile_name*90
      Integer nchar,i

      SAVE NANG,INTVL,IPOL,ANG,SZP

C PARAMETERS
      INDA=1
      INDT=1
      INDP=1
      IMTHD=2
      EPSP=0
      EPSU=0
      IPOL=1
      NTAU=1
      UTAU(1)=0
      NDA=2  !! used to be 6
      RMIN=0.01E-4
      RMAX=30.0E-4
C FILES
      IUA=1
      IUW=4
      IUR=10
      IUK=11
      OPEN(IUA,FILE='vis_IR/datafiles/MLATMD',STATUS='OLD')
      OPEN(IUK,FILE='vis_IR/datafiles/KRNL.OUT',STATUS='OLD')
      OPEN(IUR,FILE='vis_IR/datafiles/DINTPM',STATUS='OLD')
C READ CONTROL PARAMETERS FOR TRANSFER
C TH0: SOLAR ZENITH ANGLE (DEGREE)
C TH : VIEWING NADIR ANGLE (DEGREE)
C FI : AZIMUTHAL ANGLE (DEGREE)
C INDG=0: LAMBERT SURFACE, GALB: FLUX ALBEDO
C INDG=1: OCEAN SURFACE  , GALB: WIND VELOCITY (M/S) AT 10 M ABOVE SURFACE
C NW0: NUMBER OF SUB-WAVELENGTH GRIDS FOR CALCULATING RESPONSE FUNCTION
C RX(I), I=1,NW0: DW*RX=WAVELENGTH DISPLACEMENTS IN MICRON FOR GRIDS
C                 TO CALCULATE THE scaled RESPONSE FUNCTION
C RF(I), I=1,NW0: INTEGRATED scaled RESPONSE FUNCTION OF RADIOMETER
C                 as a function of RX (Relative unit is OK).
C Averaged radiance
C L = sum (I=1,N; Radiance(I)*RF(I))/sum(I=1,N; RF(I))
C Reveived energy by the radiometer
C E = C0*L
C
C       WHERE WL1(I)=WL+DW*RX(I)
C       -0.5 <= RX(I) <= 0.5
C NW : NUMBER OF WAVELENGTHS FOR GETTING RADIANCES
C WL(I), I=1,NW : WAVELENGTHS IN MICRON
C DW(I), I=1,NW : Scaling factor to define the scaled response function.
C C0(I), I=1,NW : 0-th moment of the original response function.
C                  If you don't need the absolute value of the received
C                  energy, give a dummy value.
C ISPC
C
   18 Continue
      NA0  = 1
      NA1U = 1
      NFI  = 1
      NW0  = 1
c solar zenith angle for daytime simulation
      IF(znth_slr .ge. 0.) then        !! daytime
        ISOL=1
        TH0(1) = znth_slr
       else                            !! nighttime
        ISOL=0
        TH0(1)=0
      endif
c satellite zenith angle
      TH(1) = znth_obs
c relative azimuth angle between the sun and satellite.
      FI(1) = azmth
c surface type
      If (background.eq.'water') then
         INDG = 1
c wind speed in [m/s] (may not be important)
         GALB = 5.
      Else if (background.eq.'land') then
         INDG = 0
c ground albedo
c
c Misspelling corrected (05/01/2007 by Hiro)
c in response to a comment of Toshi, NASA GSFC.
c
         GALB = 0.5
      Endif
c response function (assuming a step function)
      RX(1) = 0.
      RF(1) = 1.
c channel specification
      NW = mxwavel
      DO IW = 1 , NW
         WL(IW) = wavel(IW)
         DW(IW) = 0.
         C0(IW) = 1.
      End do
c standard atmosphere (used only for gaseous components except water vapor)
      IATM = 1  !! Tropical
      NLN  = nlyr
      NPOLY = 2
      NLN1=NLN+1
C STANDARD MODEL INTERFACE NUMBER FROM TOP TO BOTTOM
      DO I=1,NLN1
         IPB(I)=NLN1-I
      END DO
C MICROPHYSICAL CONSTANTS
      PR(1,3) = 1.E-4           !! RMIN [CM]
      PR(1,4) = 1.E0            !! RMAX [CM]
      RMIN = PR(1,3)
      RMAX = PR(1,4)
      RmodLC = 1.e-3
      RmodIC = 2.e-3
      sigmaLC = 1.419
      sigmaIC = 1.419
      PN0R = 8.e-2
C Misspelled variable corrected by H.Masunaga (Aug,07)
      PN0S = 4.e-2
C
      DO 22 I=1,NA0
   22 AM0(I)=COS(TH0(I)*RAD)
      DO 23 I=1,NA1U
   23 AM1U(I)=-COS(TH(I)*RAD)
C MODEL ATMOSPHERES
      REWIND IUA
      CALL MLATM(IUA,NL,NATM,NM1,NM2,IDM,IDMS,WMOL,RAMS,AIRM
     &   ,ALT,PMATM,TMATM,DNSTY,AMOL,TRAC,ERR)
      IF(ERR.NE.' ') GOTO 99
      DO L=1,NL
         ALTSTD(L) = ALT(L)
      End do
C
C BEGIN XY LOOP
C
      write(*,*) 'Visible/IR radiance simulation --------'
C      
      DO 100 nx = 1 , ngridx
      DO 100 ny = 1 , ngridy
C LEVEL CALCULATION (FROM TOP TO BOTTOM AT INTERFACES)
      GTMP=temp_lev(nx,ny,0)
      DO 17 L=1,NLN1
      ALT(L)=hgt_lev(IPB(L))
      PRS(L)=press_lev(nx,ny,IPB(L))/PSTD
   17 TMP(L)=temp_lev(nx,ny,IPB(L))
C GASEOUS COMPONENTS
      DO M = 1 , 7
         DO L=1,NL
            AMOLM(L) = AMOL(L,M,IATM)
         End do
         DO L = 1 , NLN
            Z=(ALT(L)+ALT(L+1))*.5
            AMOL2(L,M) = AINTP(Z,NL,ALTSTD,AMOLM)
         END DO
      End do
      DO M = 8 , 28
         DO L=1,NL
            AMOLM(L) = TRAC(L,M-7)
         End do
         DO L = 1 , NLN
            Z=(ALT(L)+ALT(L+1))*.5
            AMOL2(L,M) = AINTP(Z,NL,ALTSTD,AMOLM)
         END DO
      END DO
C Hydrometeor densities
      DO L = 1 , NLN
         relhum  = MIN(1.,relhum_avg(nx,ny,IPB(L)) * 1.e-2)
         CALL WVCAL(1,PRS(L)*PSTD,TMP(L),relhum,AMOL2(L,1),
     &              GM3,E,GM3S,ES) ! Unit Conversion (relhum->PPMV)
         CLDW(L) = MAX(cloud_water_avg(nx,ny,IPB(L)),1.E-20)
         CLDI(L) = MAX(cloud_ice_avg  (nx,ny,IPB(L)),1.E-20)
         RAIN(L) = MAX(rain_avg       (nx,ny,IPB(L)),1.E-20)
         SNOW(L) = MAX(snow_avg       (nx,ny,IPB(L)) +
     &                 graupel_avg    (nx,ny,IPB(L)),1.E-20)
         CLDW(L) = CLDW(L) * 1.e-6
         CLDI(L) = CLDI(L) * 1.e-6
         RAIN(L) = RAIN(L) * 1.e-6
         SNOW(L) = SNOW(L) * 1.e-6
      END DO
      DO 2 L=1,NLN
      DO 16 K=1,53
   16 AMTPBA(K,L)=0
      L1=L+1
      DZ=ABS(ALT(L)-ALT(L1))
      P=(PRS(L)+PRS(L1))*.5
      T=(TMP(L)+TMP(L1))*.5
      DO 4 M=1,28
         WM(M)=AMOL2(L,M)
 4    CONTINUE
CC SCALED GAS AMOUNT
      CALL SCALD(P,T,WM,IBMOL,DENSTY)
      DO 6 K=1,53
    6 AMTPBA(K,L)=AMTPBA(K,L)+DENSTY(K)*DZ
    3 CONTINUE
    2 CONTINUE
c
c Added 04/25/2007 in response to a comment from Dr. Hirose
c Just a dummy value for ISPC, which might be necessary
c to be specified for some compilers.
c
      ISPC = 1
c
c GETPH3B has been replaced with GETPH3Z, which uses an
c extended Mie Kernel to take into account large size parameters.
c
      CALL GETPH3Z(IUK,IUR,ISPC,WLC,PR,SCR,SCI
     &     ,NANG,INTVL,IPOL,ANG,SZP,R,V,PH,CEXT,CABS,CG,ERR)
C RAYLEIGH PHASE FUNCTION
      DO 1 I=1,NANG
    1 PHSM(I)=3.0/16.0/PI*(1+COS(ANG(I)*RAD)**2)
C CALCULATION OF INTEGRATED FSOL AND TAUR
  37  format('       WL  TH0   TH    FI   S0(W/M2)   EN(W/M2)'
     &,'  RD(EN/MCRN)       RF  TBB(K)')
      DO 21 IW=1, NW
c
      If ( nx.eq.1 .and. ny.eq.1 ) 
     &write(*,*) ' wavelength#: ',IW,' at',wavel(IW),' micron'
      WG0=0
      SOL=0
      DO 24 I=1,NA1U
      DO 24 J=1,NA0
      DO 24 K=1,NFI
  24  AI0(I,J,K)=0
      DO 7 IWS=1,NW0
      WL1=WL(IW)+DW(IW)*RX(IWS)
C!! 94.10.20
      IF(IWS.LE.1) THEN
        WLA=WL(IW)-DW(IW)/2
       ELSE
        WLA=WL(IW)+DW(IW)*(RX(IWS-1)+RX(IWS))/2
      ENDIF
      IF(IWS.GE.NW0) THEN
        WLB=WL(IW)+DW(IW)/2
       ELSE
        WLB=WL(IW)+DW(IW)*(RX(IWS+1)+RX(IWS))/2
      ENDIF
C!! 94.10.20 end
      NWW=LOG(WLB/WLA)/0.002
      NWW=MAX(NWW,1)
      WGT1 =RF(IWS)
      WLC=WL1*1.0E-4
      WN=10000/WL1
      IF(WL1.LE.5.0) THEN
        FSOL=SUNIR(WN)
       ELSE
        FSOL=0
      ENDIF
      IF(ISOL.EQ.0) FSOL=0
      IF(WL1.LE.2.0) THEN
        NPLK1=0
       ELSE
        NPLK1=1 !! used to be 2
      ENDIF
      TRAY=0.00864/WL1**(3.916+0.074*WL1+0.05/WL1)
C PHASE FUNCTIONS
      DO 32 L = 1, NLN
      TAUR    =ABS(PRS(L)-PRS(L+1))*TRAY
      TAURA(L)=TAUR
      SCARA(L)=TAUR
      DO 32 I=1,NANG
   32 PHSF(I,L)=PHSM(I)*TAUR
C POLYDISPERSIONS
      DO 30 IPOLY=1,NPOLY
c      DO 31 J=1,NMODE
c      DO 31 I=1,5
c   31 PR(I,J)=PR9(I,J,IPOLY)
C     PHASE FUNCTIONS
         DO 34 L = 1, NLN
            IF (RAIN(L).GT.0.) THEN
               SLPR(L) = (PI*1.*PN0R/(RAIN(L)))**.25
            ELSE
               SLPR(L) = 1.E10
            ENDIF
            IF (SNOW(L).GT.0.) THEN
               SLPS(L) = (PI*.1*PN0S/(SNOW(L)))**.25
            ELSE
               SLPS(L) = 1.E10
            ENDIF
            IF (IPOLY .EQ. 1) THEN
C CLOUD ICE
               ISPC    = 2
               PR(1,2) = 2.    !! NMODE
               PR(2,1) = 2.
               PR(4,1) = sigmaIC
               PR(3,1) = CLDI(L) / (0.917*sqrt(2.*PI)*LOG(sigmaIC))
               PR(5,1) = RmodIC
C SNOW
               PR(2,2) = 4.
               PR(3,2) = PN0S
               PR(4,2) = SLPS(L)
            ELSE IF (IPOLY .EQ. 2) THEN
C CLOUD WATER
               ISPC    = 1
               PR(1,2) = 2.    !! NMODE
               PR(2,1) = 2.
               PR(4,1) = sigmaLC
               PR(3,1) = CLDW(L) / (sqrt(2.*PI) * LOG(sigmaLC))
               PR(5,1) = RmodLC
C RAIN WATER
               PR(2,2) = 4.
               PR(3,2) = PN0R
               PR(4,2) = SLPR(L)
            ENDIF

c GETPH3B has been replaced with GETPH3Z, which uses an
c extended Mie Kernel to take into account large size parameters.
c
            CALL GETPH3Z(IUK,IUR,ISPC,WLC,PR,SCR,SCI
     &     ,NANG,INTVL,IPOL,ANG,SZP,R,V,PH,CEXT,CABS,CG,ERR)
            CSCA=CEXT-CABS
            OMGA=CSCA/CEXT
            DO 33 I=1,NANG
 33         PHSA(I)=PH(I,1)/CSCA
            DALT = (ALT(L) - ALT(L+1)) * 1.E5 ! [km] -> [cm]
            TAUA=CEXT * DALT
            TAURA(L)=TAURA(L)+TAUA
            SCARA(L)=SCARA(L)+OMGA*TAUA
            DO 34 I=1,NANG
 34         PHSF(I,L)=PHSF(I,L)+PHSA(I)*OMGA*TAUA
   30 CONTINUE
C GAS ABSORPTION
      DO 9 L=1,NLN
C Gas absorption
C Integration by finer wavelength grid:
C   mean(i=1,N) sum(k=1,3) w(i,k) f(tau(i,k)) = sum(k=1,3) w1(k) f(tau1(k))
C   then
C   w1(k) f(tau1(k)) = mean(i=1,N) w(i,k) f(tau(i,k))
C if f =1      then w1(k)=mean(i=1,N) w(i,k)
c if f =exp(-) then w1(k)tau1(k)=mean(i=1,N)w(i,k)exp(-tau(i,k))
C This is the retionale to use the averaging in the code.
      DO 11 K=1,53
   11 AMTPB(K)=AMTPBA(K,L)
      DO 35 IK=1,3
      TKD(IK,L)=0
   35 WGT(IK,L)=0
      DWWL=(WLB-WLA)/NWW
      WWL=WLA-DWWL/2
      DO 36 IWW=1,NWW
      WWL=WWL+DWWL
      WN1=10000/WWL
      CALL ABGAS1(WN1,AMTPB,AMTP,TAUM,TWGP,TX,AAA,CPSS)
      CALL TAUF(AMTP,TAUM,TWGP,TX,TAUB,WGTB)
      DO 12 IK=1,3
C 2000.2.9 Revised by T.Y.Nakajima and A.Higurashi
      TKD(IK,L)=TKD(IK,L)+TAUB(IK)*WGTB(IK)
c      TKD(IK,L)=TKD(IK,L)+exp(-TAUB(IK))*WGTB(IK)
   12 WGT(IK,L)=WGT(IK,L)+         WGTB(IK)
   36 continue
        DO 38 IK=1,3
        IF(TKD(IK,L).GT.0) then
C 2000.2.9 Revised by T.Y.Nakajima and A.Higurashi
          TKD(IK,L)=TKD(IK,L)/WGT(IK,L)
c          TKD(IK,L)=-LOG(TKD(IK,L)/WGT(IK,L))
        else
          TKD(IK,L)=5000
        endif
        WGT(IK,L)=WGT(IK,L)/NWW
   38 continue
    9 CONTINUE
C 3-CHANNELS
      DO 13 IK=1,3
C
      DO 14 L=1,NLN
      THK(L)=TKD(IK,L)+TAURA(L)
      IF(THK(L).GT.0) then
        OMG(L)=SCARA(L)/THK(L)
      else
       OMG(L)=1
       THK(L)=0
      endif
      THK(L)=MAX(THK(L),1.0E-10)
      TAUMAX=20.0/(1.04-OMG(L))
      THK(L)=MIN(THK(L),TAUMAX)
   14 continue
C PLANK FUNCTION FITTING
      BGND=0
      IF(NPLK1.GT.0) THEN
        B2=BPLNK(WL1,TMP(1))
        DO 20 L=1,NLN
        B1=B2
        B2=BPLNK(WL1,TMP(L+1))
        CPLK(1,L)=B1
   20   CPLK(2,L)=(B2-B1)/THK(L)
        IF(INDG.EQ.0) THEN
          BGND=(1-GALB)*BPLNK(WL1,GTMP)
         ELSE IF(INDG.GT.0) THEN
          BGND=BPLNK(WL1,GTMP)
        ENDIF
      ENDIF
C
      IF(SCI.GE.0)SCI=-1.0*SCI
      CALL RTRN21(INDG,INDA,INDT,INDP,IMTHD,NDA,NA1U,AM1U,NA0,AM0
     &,NFI,FI,NLN,THK,OMG,NLGN1,G,NANG,ANG,PHSF,EPSP,EPSU,GALB,FSOL
     &,NPLK1,CPLK,BGND,NTAU,UTAU,SCR,SCI,FLXD,FLXU,AI,ERR)
      IF (ERR .NE. ' ') GOTO 99
      L=1
      L9=min(L,NLN)
      DO 25 I=1,NA1U
      DO 25 J=1,NA0
      DO 25 K=1,NFI
  25  AI0(I,J,K)=AI0(I,J,K)+AI(I,J,K,L)*WGT(IK,L9)*WGT1
      WG0       =WG0       +            WGT(IK,L9)*WGT1
      SOL       =SOL       +       FSOL*WGT(IK,L9)*WGT1
   13 CONTINUE
    7 CONTINUE
      WL1=WL(IW)
      DO 26 I=1,NA1U
      DO 26 J=1,NA0
      DO 26 K=1,NFI
      RD1=AI0(I,J,K)/WG0
      IF (WL1 .LE. 4.0) THEN
        TBB1=0
       ELSE
	TBB1=TBB(WL1,RD1)
      ENDIF
      IF ( WL1.lt.10. ) THEN
         I_visIR(nx,ny,IW) = RD1
      ELSE
         I_visIR(nx,ny,IW) = TBB1
      ENDIF
CCC      WRITE(*,*) nx,ny,WL1,RD1,TBB1
 26   Continue
   15 FORMAT(F9.4,2F5.1,F6.1,1p,4E11.3,0P,F8.2)
   21 CONTINUE
 100  CONTINUE
c
      Close ( IUA )
      Close ( IUK )
      Close ( IUR )
c
      RETURN
c
 99   Write(*,*) 'ERROR :',ERR
      STOP
c
      END
