      SUBROUTINE ADD(IT,NA0,N1,N2,N3,R1D,R1U,T1D,T1U,S1D,S1U
     & ,R2D,T2D,T2U,S2D,S2U,TU,RD,SD,SU,ERR)
C ADDING TWO LAYERS 1 AND 2.
C--- HISTORY
C 86.10.15  CHECK OK.
C 89.10.30  RE-EDIT.
C 90. 2. 2  ELEMINATE KND00
C--- INPUT
C IT         I      INDICATOR FOR CALCULATION OF TU AND SD.
C NA0        I      NO. OF SOLAR DIRECTIONS.
C N1,N2,N3   I       ----------------------------     MU1(I), I=1,N1
C R1D, R1U R(KNDM,   R1D, R1U, T1D, T1U, S1D, S1U    (LAYER-1)
C T1D, T1U   KNDM)   ----------------------------     MU2(I), I=1,N2
C R2D, R2U           R2D, R2U, T2D, T2U, S2D, S2U    (LAYER-2)
C T2D, T2U           ----------------------------     MU3(I),I=1,N3
C S1D, S1U R(KNDM,   SUFFIX U = UPGOING,   D = DOWNGOING INCIDENCES.
C S2D, S2U   KNA0)          R = REFLECTION,T = TRANSMISSION MATRICES.
C                           S = SOURCE MATRIX.
C--- OUTPUT
C RD       R(KNDM,   -----------------    MU1(I), I=1,N1
C TU         KNDM)   RD, TU, SD, SU       (LAYER 1+2)
C SD       R(KNDM,   -----------------    MU3(I), I=1,N3
C SU         KNA0)
C ERR       C*64     ERROR INDEX.
C--- PARAMETER
C KNA0       I       NUMBER OF SOLAR ZENITH ANGLES.
C KNDM       I       NUMBER OF QUADRATURE POINTS.
C--- AREAS FOR THIS ROUTINE
c
      Include 'VISIRparameters.inc'
c
CC      PARAMETER (KNA0  =10)
CC      PARAMETER (KNDM  =10)
C
      CHARACTER ERR*64
      DIMENSION R1D(KNDM,KNDM),R1U(KNDM,KNDM),T1D(KNDM,KNDM)
     &,T1U(KNDM,KNDM),S1D(KNDM,KNA0),S1U(KNDM,KNA0)
     &,R2D(KNDM,KNDM),T2D(KNDM,KNDM),T2U(KNDM,KNDM)
     &,S2D(KNDM,KNA0),S2U(KNDM,KNA0)
     &,TU(KNDM,KNDM),RD(KNDM,KNDM),SD(KNDM,KNA0),SU(KNDM,KNA0)
C--- WORKING AREAS
      DIMENSION AA(KNDM,KNA0),BB(KNDM,KNDM),CC(KNDM,KNDM),DD(KNDM,KNDM)
C
      CALL AXB(AA,R2D,S1D,N2,N2,NA0,KNDM,KNDM,KNDM)
      CALL APB(SU,AA,S2U,N2,NA0,KNDM,KNDM,KNDM)
      CALL AXB(CC,R2D,R1U,N2,N2,N2,KNDM,KNDM,KNDM)
      CALL MULTI(N2,CC,BB,ERR)
      IF(ERR.NE.' ') THEN
        ERR='ERROR IN MULTI OF ADD'
        RETURN
      ENDIF
      CALL AXB(SD,BB,SU,N2,N2,NA0,KNDM,KNDM,KNDM)
      CALL AXB(SU,T1U,SD,N1,N2,NA0,KNDM,KNDM,KNDM)
      CALL AAPB(SU,S1U,N1,NA0,KNDM,KNDM)
      CALL AXB(CC,T1U,BB,N1,N2,N2,KNDM,KNDM,KNDM)
      CALL AXB(DD,R2D,T1D,N2,N2,N1,KNDM,KNDM,KNDM)
      CALL AXB(BB,CC,DD,N1,N2,N1,KNDM,KNDM,KNDM)
      CALL APB(RD,R1D,BB,N1,N1,KNDM,KNDM,KNDM)
      IF(IT.LE.0) RETURN
      CALL AXB(TU,CC,T2U,N1,N2,N3,KNDM,KNDM,KNDM)
      CALL AXB(AA,R1U,SD,N2,N2,NA0,KNDM,KNDM,KNDM)
      CALL AAPB(AA,S1D,N2,NA0,KNDM,KNDM)
      CALL AXB(SD,T2D,AA,N3,N2,NA0,KNDM,KNDM,KNDM)
      CALL AAPB(SD,S2D,N3,NA0,KNDM,KNDM)
      RETURN
      END
