      FUNCTION AINTP(XX,N,X,Y)
C$NAME  AINTP
C LINEAR INTERPOLATION
C--- HISTORY
C 90. 3. 6 CREATED
C--- INPUT
C XX    R     INTERPOLATION POINT
C N     R     NBR OF DATA
C X   R(NN)   INDEPENDENT VARIABLE,  X(I) .LT. X(I+1)
C Y   R(NN)   DEPENDENT   VARIABLE
C--- OUTPUT
C AINTP R     OUTPUT
C$ENDI
C
      DIMENSION X(*),Y(*)
C 1 POINT
      IF(N.LE.1) THEN
      AINTP=Y(1)
      RETURN
      ENDIF
C 2 POINTS OR XX.LE.X(1)
      IF(XX.LE.X(1) .OR. N.EQ.2) THEN
      AINTP=Y(1)+(Y(2)-Y(1))*(XX-X(1))/(X(2)-X(1))
      RETURN
      ENDIF
C XX.GE.XX(N)
      IF(XX.GE.X(N)) THEN
      AINTP=Y(N-1)+(Y(N)-Y(N-1))*(XX-X(N-1))/(X(N)-X(N-1))
      RETURN
      ENDIF
C MORE THAN 2 POINTS
      DO 1 I=1,N
      IF(XX.LE.X(I)) GOTO 2
    1 CONTINUE
      I=N
    2 K1=MAX(1,I-1)
      K2=K1+1
      IF(K2.GT.N) THEN
        K2=N
        K1=K2-1
      ENDIF
C
      AINTP=Y(K1)+(Y(K2)-Y(K1))*(XX-X(K1))/(X(K2)-X(K1))
      RETURN
      END
