      SUBROUTINE FRNLR(CR,CI,WI,WR,R1,R2)
C FRESNEL REFLECTION COEFFICIENTS
C--- HISTORY
C 88. 6.16  CREATED
C--- INPUT
C CR      R      REAL PART OF THE COMPLEX REFRACTION INDEX
C CI      R      IMAGINARY PART M = CR + I*CI
C WI      R      INCIDENT ANGLE IN DEGREES
C--- OUTPUT
C WR      R      REFRACTION ANGLE IN DEGREES
C                IF TOTAL REFLECTION, THEN WR=999
C R1      R      REFLECTIVITY FOR POLARIZATION
C R2      R      REFLECTIVITY FOR POLARIZATION
C--- REFERENCE
C K.-N. LIOU
C$ENDI
      PARAMETER (PI=3.141592653, RD=PI/180.0)
      CI1=-CI
      C=COS(WI*RD)
      S=SIN(WI*RD)
      WR=S/CR
      IF(WR.GT.1.0) THEN
      WR=999
      ELSE
      WR=ASIN(WR)/RD
      ENDIF
      EN1=CR**2-CI1**2
      EN2=2*CR*CI1
      EN3=EN1-S**2
      U=SQRT(ABS(EN3+SQRT(EN3**2+EN2**2))/2)
      V=SQRT(ABS(U**2-EN3))
      U2=U**2+V**2
      R1=1/(U*C/(U2+C**2)+0.5)-1
      R2=1/((EN1*U+EN2*V)*C/((EN1**2+EN2**2)*C**2+U2)+0.5)-1
      RETURN
      END
