      SUBROUTINE GETQM(IW0,N,X,Y,ZEIG,Q,QI,XI,IMN,ERR)
C SOLVE    XY = Q ZEIG**2 INVERSE(Q)
C ROOT DECOMPOSITION METHOD
C--- HISTORY
C 89. 8. 4 CREATED
C--- INPUT
C IW0       I        IF 1 THEN RENOMALIZATION (FOR M=0 AND W0=1)
C N         I        ORDER OF MATRICES
C X     R(KNDM,KNDM) SYMMETRIC MATRIX
C Y     R(KNDM,KNDM) SYMMETRIC MATRIX
C--- OUTPUT
C ZEIG    R(KNDM)    SQRT(EIGENVALUE)
C Q     R(KNDM,KNDM) ROTATION MATIX
C QI    R(KNDM,KNDM) INVERSE OF Q
C XI    R(KNDM,KNDM) INVERSE OF X
C IMN       I        LOCATION OF MINIMUM EIGENVALUE
C ERR     C*64       ERROR INDICATER
C--- PRPC-PARAMETER
C KNDM      I        DECLARED SIZE OF MATRICES
C
      Include 'VISIRparameters.inc'
c
C      PARAMETER (KNDM  =10)
      CHARACTER ERR*(*)
      DIMENSION X(KNDM,KNDM),Y(KNDM,KNDM),ZEIG(KNDM),Q(KNDM,KNDM)
     & ,QI(KNDM,KNDM),XI(KNDM,KNDM)
C WORKING AREA
      PARAMETER (KROWIJ=(KNDM*(KNDM+1))/2)
      DIMENSION V(KNDM,KNDM),SQX(KNDM,KNDM),SQXI(KNDM,KNDM)
     & ,ROWIJ(KROWIJ),WK(KNDM)
C ROOT DECOMPOSITION OF X (USE V AND ZEING FOR U AND XEIG).
      ERR=' '
      K=0
      DO 1 I=1,N
      DO 1 J=1,I
      K=K+1
    1 ROWIJ(K)=X(I,J)
      CALL SYMTRX(ROWIJ,N,ZEIG,V,KNDM,WK,IERR)
      IF(IERR.GT.128) THEN
        ERR='ERROR IN DECOMPOSITION OF X IN GETQM'
        RETURN
      ENDIF
      DO 2 I=1,N
      IF(ZEIG(I).LE.0.0) THEN
        ERR='NON-POSITIVE EIGENVALUE OF X'
        RETURN
      ENDIF
    2 ZEIG(I)=SQRT(ZEIG(I))
      DO 5 I=1,N
      DO 5 J=1,N
      SUM1=0
      SUM2=0
      SUM3=0
      DO 6 K=1,N
      SUM1=SUM1+V(I,K)*ZEIG(K)*   V(J,K)
      SUM2=SUM2+V(I,K)/ZEIG(K)*   V(J,K)
    6 SUM3=SUM3+V(I,K)/ZEIG(K)**2*V(J,K)
      SQX (I,J)=SUM1
      SQXI(I,J)=SUM2
    5 XI  (I,J)=SUM3
      CALL AXB(V,SQX,Y,N,N,N,KNDM,KNDM,KNDM)
      CALL AXB(Q,V,SQX,N,N,N,KNDM,KNDM,KNDM)
C ROOT DECOMPOSITION OF Z (USE Q FOR Z).
      K=0
      DO 7 I=1,N
      DO 7 J=1,I
      K=K+1
    7 ROWIJ(K)=Q(I,J)
      CALL SYMTRX(ROWIJ,N,ZEIG,V,KNDM,WK,IERR)
      IF(IERR.GT.128) THEN
        ERR='ERROR IN DECOMPOSITION OF Z IN GETQM'
        RETURN
      ENDIF
C CHECK MINIMUM EIGENVALUE
      IMN=1
      ZMN=ZEIG(1)
      IF(N.GE.2) THEN
        DO 8 J=2,N
        IF(ZEIG(J).LT.ZMN) THEN
          IMN=J
          ZMN=ZEIG(J)
        ENDIF
    8   CONTINUE
      ENDIF
C RENORMALIZATION
      IF(IW0.EQ.1) ZEIG(IMN)=0
C
      DO 9 I=1,N
      IF(ZEIG(I).LT.0.0) THEN
        ERR='NON-POSITIVE EIGENVALUE OF Z'
        RETURN
      ENDIF
    9 ZEIG(I)=SQRT(ZEIG(I))
C Q-MATRICES
      DO 10 I=1,N
      DO 10 J=1,N
      SUM1=0
      SUM2=0
      DO 11 K=1,N
      SUM1=SUM1+SQX(I,K)*V(K,J)
   11 SUM2=SUM2+V(K,I)*SQXI(K,J)
      Q (I,J)=SUM1
   10 QI(I,J)=SUM2
      RETURN
      END
      SUBROUTINE GETQM2( N ,X ,Y ,AM1, ZEIG ,Q ,QI ,XI ,ERR )
C$NAME GETQM2
C$LINK AXB
C     SOLVE    XY = Q ZEIG**2 INVERSE(Q)
C     IN CASE THAT XY IS A DIAGONAL MATRIX
C---  HISTORY
C     89. 8. 4 CREATED
C---  INPUT
C     N         I        ORDER OF MATRICES
C     X     R(KNDM,KNDM) SYMMETRIC MATRIX
C     Y     R(KNDM,KNDM) SYMMETRIC MATRIX
C     AM1   R(KNDM)      MU(I), I=1,N
C---  OUTPUT
C     ZEIG    R(KNDM)    SQRT(EIGENVALUE)
C     Q     R(KNDM,KNDM) ROTATION MATIX
C     QI    R(KNDM,KNDM) INVERSE OF Q
C     XI    R(KNDM,KNDM) INVERSE OF X
C     ERR     C*64       ERROR INDICATER
C---  PRPC-PARAMETER
C     KNDM      I        DECLARED SIZE OF MATRICES
C
C$PRPC
C
      Include 'VISIRparameters.inc'
c
C      PARAMETER ( KNDM = 10 )
      CHARACTER ERR*(*)
      DIMENSION X(KNDM,KNDM) ,Y(KNDM,KNDM) ,ZEIG(KNDM) ,Q(KNDM,KNDM)
     &     ,QI(KNDM,KNDM) ,XI(KNDM,KNDM), AM1(KNDM)
C     WORKING AREA
      DIMENSION GMTRX(KNDM,KNDM)

      ERR = ' '
      CALL AXB(GMTRX,X,Y,N,N,N,KNDM,KNDM,KNDM)
      DO 1 I = 1 , N
         DO 2 J = 1 , N
            Q(I,J)  = 0.
            QI(I,J) = 0.
            XI(I,J) = 0.
 2       CONTINUE
         IF (GMTRX(I,I).le.0.) THEN
            ERR = 'ERR IN G-MTRX IN GETQM2'
            RETURN
         ENDIF
         ZEIG(I) = SQRT(GMTRX(I,I))
         Q(I,I)  = 1. / SQRT(AM1(I))
         QI(I,I) = SQRT(AM1(I))
         XI(I,I) = 1. / X(I,I)
 1    CONTINUE

      RETURN
      END
