      SUBROUTINE GRNDO1(INDG,FSOL,U10,BGND,DPT,M,NDA,WMP,NA0,AM0
     &   ,CR,CI,R,T,ER,ERT,ET,AMUA,WA)
C--- HISTORY
C 89.11. 2
C
C 93. 2.26  BUG BG
C     3. 2  CHENGED CALCULATION OF EMISSIVITY
C     3.24  SUB.OCNRF3 Changed parameter ( add wa )
C     4. 5  Put SAVE
C     4. 5 NSF = 1 for initialization (Terry)
C     5. 4 NSF -> INDG; N1, N0 change name as NDA, NA0
C          IF(NSF.GT.0) -> IF(INDG.EQ.1)
C 95. 6. 2 Generated from GRNDO with CR and CI
C 96. 1.12  EMS(KNA0)
C 97. 3.17 Add ERT By Takashi Nakajima to Thermal.
C 98. 2. 4  Replace EMS(KNA0)->EMS(KNDM)
C--- INPUT
C INDG       I           1 then Initialization of ocean surface matrix
C                        Otherwise use the calculated matrices.
C FSOL       R           SOLAR IRRADIANCE AT THE SYSTEM TOP.
C U10        R           WIND VELOCITY IN M/S AT 10M HEIGHT
C BGND       R           Plank INTENSITY FROM THE SURFACE
C                        Emitted thermal is calculated as (1-r)*BGND
C                        where r is unidirectional reflectivity.
C                        Note the definition of BGND is different
C                        from that for GRNDL.
C DPT        R           OPTICAL DEPTH AT THE SURFACE.
C M          I           FOURIER ORDER.
C NDA        I           NUMBER OF QUADRATURE POINTS.
C WMP     R(KNDM)        SQRT(WM)
C NA0        I           NUMBER OF SOLAR ANGLES.
C AM0     R(KNA0)        COS(SOLAR ZENITH ANGLE)
C                        Needs all the m-Fourier components
C CR         R           Relative refractive index of the media
C                        About 1.33 for atmosphere to ocean incidence,
C                        and 1/1.33 for ocean to atmosphere incidence.
C CI         R           Relative refractive index for imaginary part
C                        M = CR + I*CI
C--- OUTPUT
C R      R(KNDM,KNDM)    SCALED REFELCTION MATRIX.
C T      R(KNDM,KNDM)    SCALED TRANSMISSION MATRIX.
C ER     R(KNDM,KNA0)    SCALED SOURCE MATRIX FOR UPWARD RADIANCE.
C ET     R(KNDM,KNA0)    SCALED SOURCE MATRIX FOR DOWNWARD RADIANCE.
C
C OCEAN SURFACE
C
      Include 'VISIRparameters.inc'
c
      SAVE ORF,SRR
C      PARAMETER (KNDM  =10)
C      PARAMETER (KNA0  =10)
      PARAMETER (PI=3.141592654)
      DIMENSION R(KNDM,KNDM),T(KNDM,KNDM),ER(KNDM,KNA0),ET(KNDM,KNA0)
     &         ,AM0(KNA0),WMP(KNDM),AMUA(KNDM),WA(KNDM)
C98.2.4 Replace EMS(KNA0)->EMS(KNDM)
      DIMENSION ORF(KNDM,KNDM,KNDM2),EMS(KNDM),SR(KNDM)
     &         ,SRR(KNDM,KNA0,KNDM2)

      DIMENSION ERT(KNDM,KNA0)

      M1=M+1
      IF(INDG.EQ.1) THEN
        CALL OCNR11(M,NDA,AMUA,WA,CR,CI,U10,R)
        CALL EQ32(ORF,R,NDA,NDA,M1,KNDM,KNDM,KNDM2,KNDM,KNDM)
C 93.3.2
        DO 5 J=1,NA0
        CALL OCNR31(M,NDA,AMUA,WA,AM0(J),CR,CI,U10,SR)
        DO 5 I=1,NDA
    5   SRR(I,J,M1)=SR(I)
C
      ENDIF
      DO 2 I=1,NDA
      DO 2 J=1,NDA
      T(I,J)=0.0
   2  R(I,J)=WMP(I)*ORF(I,J,M1)/WMP(J)
C 93.3.2
      IF(M.EQ.0)THEN
        BG=2*PI*BGND

C98.2.4 Replace 'DO 3'  by T.Y.Nakajima
C Refer Katagiri's Modification.
C        DO 3 J=1,NA0
C        SUM=0
C        DO 4 I=1,NDA
C   4    SUM=SUM+AMUA(I)*WA(I)*SRR(I,J,1)
C   3    EMS(J)=1-SUM/AM0(J)

         DO 3 I=1,NDA
         SUM=0.
         DO 4 J=1,NDA
    4    SUM=SUM+ORF(I,J,1)
    3    EMS(I)=1-SUM
C
      ELSE
        BG=0
      ENDIF
        DO 1 J=1,NA0
          X=-DPT/AM0(J)
          TRNS0=EXP(X)*FSOL
          DO 1 I=1,NDA
          ET(I,J)=0.
C 98.2.4 Replace 'ERT=' by T.Y.Nakajima
C Refer Katagiri's Modification.
C 97.3.17 Add ERT By Takashi Nakajima
C        ERT(I,J)=WMP(I)*(EMS(J)*BG)
C  1     ER(I,J)=WMP(I)*(SRR(I,J,M1)*TRNS0+EMS(J)*BG)

         ERT(I,J)=WMP(I)*(EMS(I)*BG)
    1    ER(I,J)=WMP(I)*(SRR(I,J,M1)*TRNS0+EMS(I)*BG)

      RETURN
      END
      SUBROUTINE GRNDL3(FSOL,GALB,BGND,DPT,M,N1,AM,W,N0,AM0,R,T,ER,ET)
C--- HISTORY
C 95. 5.26 Generated from GRNDL introducing AM and W
C            and R=2*GALB... -> SUMWM*GALB...
C--- INPUT
C FSOL       R           SOLAR IRRADIANCE AT THE SYSTEM TOP.
C GALB       R           FLUX REFLECTIVITY OF THE SURFACE.
C BGND       R           THERMAL INTENSITY FROM THE SURFACE=(1-r)*PLANK.
C DPT        R           OPTICAL DEPTH AT THE SURFACE.
C M          I           FOURIER ORDER.
C N1         I           NUMBER OF QUADRATURE POINTS.
C AM      R(KNDM)        MU(I)
C W       R(KNDM)        W (I)
C N0         I           NUMBER OF SOLAR ANGLES.
C AM0     R(KNA0)        COS(SOLAR ZENITH ANGLE)
C--- OUTPUT
C R      R(KNDM,KNDM)    SCALED REFELCTION MATRIX.
C T      R(KNDM,KNDM)    SCALED TRANSMISSION MATRIX.
C ER     R(KNDM,KNA0)    SCALED SOURCE MATRIX FOR UPWARD RADIANCE.
C ET     R(KNDM,KNA0)    SCALED SOURCE MATRIX FOR DOWNWARD RADIANCE.
C
C LAMBERT SURFACE
C
      Include 'VISIRparameters.inc'
c
      PARAMETER (PI=3.141592654)
c      PARAMETER (KNDM  =10)
c      PARAMETER (KNA0  =10)
      DIMENSION R(KNDM,KNDM),T(KNDM,KNDM),ER(KNDM,KNA0),ET(KNDM,KNA0)
     & ,AM0(KNA0),AM(KNDM),W(KNDM)
      SUMWM=0
      DO 3 I=1,N1
    3 SUMWM=SUMWM+AM(I)*W(I)
      IF(GALB.LE.0.0 .OR. M.GT.0) THEN
        CALL EQ20( R,0.0,N1,N1,KNDM,KNDM)
        CALL EQ20( T,0.0,N1,N1,KNDM,KNDM)
       ELSE
        DO 2 I=1,N1
        DO 2 J=1,N1
        T (I,J)=0
    2   R (I,J)=GALB*SQRT(AM(I)*W(I)*AM(J)*W(J))/SUMWM
      ENDIF
      IF(M.GT.0) THEN
        CALL EQ20(ER,0.0,N1,N0,KNDM,KNA0)
        CALL EQ20(ET,0.0,N1,N0,KNDM,KNA0)
       ELSE
        DO 1 J=1,N0
          TRNS0=EXP(-DPT/AM0(J))*FSOL
          X=GALB*AM0(J)*TRNS0/SUMWM+2*PI*BGND
          DO 1 I=1,N1
          ET(I,J)=0
    1     ER(I,J)=SQRT(AM(I)*W(I))*X
      ENDIF
      RETURN
      END
