      FUNCTION HF(TAU,AM1,AM2,AM3)
C GEOMETRICAL FACTOR FOR THE SCONDERY SCATTERING EQ.(24) OF NT.
C    HF=INTEG(0,TAU)DT*INTEG(0,T)DT1*EXP(T*(1/MU1-1/MU2)
C             + T1*(1/MU2-1/MU3))*EXP(-TAU/AM1)/AM1/AM2
C--- REFERENCE
C NT:  T. NAKAJIMA AND M. TANAKA, 1988, JQSRT, 40, 51-69
C--- HISTORY
C 88. 9.22  CREATED BY T. NAKAJIMA
C 89. 5. 4  USE EXPFN
C--- INPUT
C TAU      R         OPTICAL THICKNESS OF THE LAYER.
C AM1      R         COS(ZENITH ANGLE-1).
C AM2      R         COS(ZENITH ANGLE-2).
C AM3      R         COS(ZENITH ANGLE-3).
C--- OUTPUT
C HF       F         GEOMETRICAL FACTOR.
C
      SAVE INIT,EPS
      DIMENSION CCP(3)
      DATA INIT/1/
C
C SET EPS: IF ABS(1/AM1 - 1/AM0)*TAU .LE. EPS THEN
C                      THE ROUTINE SETS ALMUCANTAR CONDITION-IALM.
      IF(INIT.GT.0) THEN
        INIT=0
        CALL CPCON(CCP)
        EPS=CCP(1)*30
      ENDIF
C
      X1=1/AM1-1/AM2
      X2=1/AM2-1/AM3
      X3=1/AM1-1/AM3
      EX1=-TAU/AM1
      EX2=-TAU/AM2
      EX3=-TAU/AM3
      EX1=EXPFN(EX1)
      EX2=EXPFN(EX2)
      EX3=EXPFN(EX3)
C
      IF(ABS(X2*TAU).LE.EPS) GOTO 1
C X2 <> 0
CC I1
      IF(ABS(X3*TAU).LE.EPS) THEN
        AI1=EX1*(TAU+X3*TAU*TAU/2)
       ELSE
        AI1=(EX3-EX1)/X3
      ENDIF
CC I2
      IF(ABS(X1*TAU).LE.EPS) THEN
        AI2=EX1*(TAU+X1*TAU*TAU/2)
       ELSE
        AI2=(EX2-EX1)/X1
      ENDIF
      HF=(AI1-AI2)/AM1/AM2/X2
      RETURN
C X2 =  0
    1 IF(ABS(X1*TAU).LE.EPS) THEN
        HF=TAU**2*(0.5-X1*TAU/3)*EX1/AM1/AM2
       ELSE
        HF=((TAU-1/X1)*EX2+EX1/X1)/AM1/AM2/X1
      ENDIF
      RETURN
      END
