      FUNCTION TAUBF(AMTP,TX,AAA,CPSS)
C TOTAL EFFECTIVE OPTICAL THICKNESS FOR THE EFFECTIVE ABSORBER AMOUNT
C -W*AMTP-, BY RANDOM MODEL
      DIMENSION AMTP(28),TX(28),AAA(28),CPSS(28)
C ADD N2 CONTINUUM
      TAUBF=TX(22)
      DO 1 M=1,11
      W1=AMTP(M)
      TAU=0
      IF (W1 .LT. 1.0E-20) GOTO 1
      IF (CPSS(M) .LE. -20) GOTO 1
C ALOG10 -> LOG10 (94.3.26)
      WS=LOG10(W1)+CPSS(M)
      QAWS=AAA(M)*WS
      IF(QAWS .GE. 2.0) THEN
        TAU=30
       ELSE
        IF (QAWS .GT. -6.0)  TAU=10.0**QAWS
      ENDIF
    1 TAUBF=TAUBF+TAU+TX(M)
      RETURN
      END
      SUBROUTINE TAUF(AMTP,TAUM,TWGP,TX,TAU,WGT)
C Synthesize optical thickness and k-distribution for the airmass.
C--- HISTORY
C 93. 6. 8 CREATED
C--- INPUT
C AMTP     R(11)    SCALED ABSORBER AMOUNT FOR EACH BAND
C TX       R(11)    ABSORPTION OPTICAL THICKNESS FOR
C                    CONTINUUM ABSORPTION
C TAUM   R(3,11)    K-VALUES IN THREE TERM K-DISTRIBUTION MODEL
C TWGP   R(3,11)    K-DISTRIBUTIONS
C--- OUTPUT
C TAU      R(3)     Optical thickness in the three term k-approximation
C WGT      R(3)     Weights

      DIMENSION AMTP(28),TAUM(3,28),TWGP(3,28),TX(28),TAU(3),WGT(3)
      DO 1 K=1,3
      TAUM1=0
      TWGP1=0
      DO 2 M=1,11
        TAUM1= TAUM1 + AMTP(M)*TAUM(K,M)
    2   TWGP1= TWGP1 + AMTP(M)*TWGP(K,M)
      IF(TAUM1 .NE. 0) THEN
        TWGP1 = TWGP1 / TAUM1
       ELSE
        TWGP1=1/3.0
      ENDIF
      TAU(K)=TAUM1
    1 WGT(K)=TWGP1
C ADD N2 CONTINUUM
      EX=TX(22)
      DO 3 M=1,11
    3 EX=EX+TX(M)
      DO 4 K=1,3
    4 TAU(K)=TAU(K)+EX
      RETURN
      END
